using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Cors;
using Microsoft.AspNetCore.Mvc;
using System;
using WK_KLI_LAPS_Service.App_Data;
using WK_KLI_LAPS_Service.Models.Master;

namespace WK_KLI_LAPS_Service.Controllers.Master.Stage
{
    [EnableCors("CorsPolicy")]
    [Authorize]
    [ApiController]
    [Route("api/[controller]")]
    public class StageApiController : ControllerBase
    {
        CommonRepository oCommonRepository = new CommonRepository();

        private IStageService _Stageservices;
        public StageApiController(IStageService StageServices)
        {
            _Stageservices = StageServices;

        }


        [Authorize]
        [HttpGet]
        //Code to retrieve all data
        public IActionResult GetAll()
        {
            var _list = _Stageservices.GetAll();
            return Ok(_list);
        }

        [Authorize]
        [HttpGet("GetActiveStage")]
        //Code to retrieve active data
        public IActionResult GetActiveStage()
        {
            var _list = _Stageservices.GetActiveStage();
            return Ok(_list);
        }
        //Code to add new record
        [Authorize]
        [HttpPost("Add")]
        public IActionResult Add([FromBody] stageModel ostageModel)
        {

            int retval = 0;
            try
            {
                retval = _Stageservices.Add(ostageModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }
        //Code to update specific record
        [Authorize]
        [HttpPost("Update")]
        public IActionResult Update([FromBody] stageModel ostageModel)
        {
            int retval = 0;
            try
            {
                retval = _Stageservices.Edit(ostageModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }

        }


        //Code to activate or deactivate specific record
        [Authorize]
        [HttpPost("activeordeactive")]
        public IActionResult Delete([FromBody] stageModel ostageModel)
        {
            int retval = 0;
            try
            {
                retval = _Stageservices.Delete(ostageModel);
                return Ok(retval);
            }
            catch (Exception ex)
            {
                oCommonRepository.ErrorLog(ex);
                // return error message if there was an exception
                return BadRequest(new { message = ex.Message });
            }
        }
    }
}